cdef class Vector3:
    cdef double x
    cdef double y
    cdef double z    

    def __init__(self, double x, double y, double z):
        self.x, self.y, self.z = x, y, z

    def __getattr__(self, name):
        if name == 'x':
            return self.x
        elif name == 'y':
            return self.y
        elif name == 'z':
            return self.z
        else:
            raise AttributeError, 'Vector3 instance has no attribute "%s"' % name
    
    def __add__(Vector3 a, Vector3 b):
        return Vector3(a.x + b.x, a.y + b.y, a.z + b.z)

    cdef int __nonzero__(Vector3 self):
        return self.x or self.y or self.z

    def __str__(self):
        return 'Vector3(x=%s, y=%s, z=%s)' % (self.x, self.y, self.z)

    # __str__ = __repr__ is not allowed
    def __repr__(self):
        return 'Vector3(x=%r, y=%r, z=%r)' % (self.x, self.y, self.z)
