"""Do the summing ourselves"""

cdef extern from "math.h":
    double sqrt(double x)
    double ceil(double x)    
from operator import add

cdef object _calculate_factors(int x):
    cdef int sqrt_x, i
    
    factors = [1]
    sqrt_x = ceil(sqrt(x))
    for i from 2 <= i < sqrt_x:
        if x % i == 0:
            factors.append(i)
            factors.append(x / i)
            
    if sqrt_x ** 2 == x: factors.append(sqrt_x)
    return factors

def is_perfect(int x):
    cdef int sum
    cdef int i 

    sum = 0
    for i in _calculate_factors(x):
        sum = sum + i

    return sum == x